// 002 p_genc_036_generic_method
// 03 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)
{$APPTYPE CONSOLE}

program p_genc_036_generic_method;
  uses SysUtils,
  u_c_genc_36_generic_class_method in 'u_c_genc_36_generic_class_method.pas',
  u_c_genc_36_generic_method in 'u_c_genc_36_generic_method.pas';

  procedure use_generic_class_method;
    var l_entier_1, l_entier_2: Integer;
        l_double_1, l_double_2: Double;
    begin
      l_entier_1:= 10; l_entier_2:= 200;
      writeln('original ', l_entier_1: 5, l_entier_2: 5);
      c_sort.swap<Integer>(l_entier_2, l_entier_1);
      writeln('    swap ', l_entier_1: 5, l_entier_2: 5);
      writeln;
      l_double_1:= 1.11; l_double_2:= 333.33;
      writeln('original ', l_double_1: 7: 2, ' ', l_double_2: 7: 2);
      c_sort.swap<Double>(l_double_1, l_double_2);
      writeln('    swap ', l_double_1: 7: 2, ' ', l_double_2: 7: 2);
    end; // use_generic_class_method

  procedure use_generic_method;
    var l_c_product: c_product;
    begin
      l_c_product:= c_product.create_product(218.15, 34);

      l_c_product.display<Double>( 'the price is    ', l_c_product.m_price);
      l_c_product.display<Integer>('the quantity is ', l_c_product.m_quantity);
    end; // use_generic_method


  begin // main
    // use_generic_class_method;
    writeln;

    use_generic_method;

    writeln; write('type enter'); Readln;
  end. // main


